﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals.WoWObjects;
using System.Windows.Media;

namespace RepairNow {
    public class RepairNow : HBPlugin {
        public override string Name { get { return "RepairNow"; } }
        public override string Author { get { return "jkljkljkl123"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return false; } }

        private static readonly LocalPlayer Me = StyxWoW.Me;
        public override void Pulse() {
            //do nothing when: taxi, dead, ghost, casting
            if (Me.OnTaxi || Me.IsDead || Me.IsGhost || Me.IsCasting || Me.IsChanneling || Me.Combat) {
                return;
            }
			
            double Durability = StyxWoW.Me.DurabilityPercent * 100;
			if (Durability < 60) {
				//vector: 32641 for the horde, 32639 for the alliance
				int vectorId = Me.IsHorde ? 32641 : 32639;
				IEnumerable<WoWUnit> vectors = ObjectManager.GetObjectsOfType<WoWUnit>().Where(o => (o.Entry == vectorId) && o.WithinInteractRange);
				if(vectors.Count()>0) {
					foreach (WoWUnit vector in vectors) {
						if (vector != null) {
							vector.Interact();
							if (Me.CurrentTarget != null && Me.CurrentTarget.Entry == vectorId){
								Styx.CommonBot.Vendors.RepairAllItems();
							}
						}
					}
				}else {
					//spell: 32641 for the horde, 32639 for the alliance
					int spellId = Me.IsHorde ? 61447 : 61425;
					if (!Me.HasAura(spellId) && Me.IsOutdoors) {
						WoWMovement.MoveStop();
						SpellManager.CastSpellById(spellId);
					}
				}
			}
		}
	}
}

